- [HTTP request](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.request_body)
- [Response body](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.ListKeyRingsResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.aspect)
- [Try it!](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#try-it)

**Full name**: projects.locations.keyRings.list

Lists `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings#KeyRing`.

### HTTP request

Choose an endpoint:
global europe-west6 us-east7 europe-west3 us-west8 europe-west9 me-central2 us-east1 us-west1 us-west3 us-central2 us-east4 us-west2 europe-west8 us-central1 us-west4 us-east5 us-south1 northamerica-northeast1 northamerica-northeast2 us in ca   
`GET https://cloudkms.googleapis.com/v1/{parent=projects/*/locations/*}/keyRings`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The resource name of the location associated with the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings#KeyRing`, in the format `projects/*/locations/*`. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `parent`: - `cloudkms.keyRings.list` |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` Optional. Optional limit on the number of `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings#KeyRing` to include in the response. Further `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings#KeyRing` can subsequently be obtained by including the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.ListKeyRingsResponse.FIELDS.next_page_token` in a subsequent request. If unspecified, the server will pick an appropriate default. |
| `pageToken` | `string` Optional. Optional pagination token, returned earlier via `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.ListKeyRingsResponse.FIELDS.next_page_token`. |
| `filter` | `string` Optional. Only include resources that match the filter in the response. For more information, see [Sorting and filtering list results](https://cloud.google.com/kms/docs/sorting-and-filtering). |
| `orderBy` | `string` Optional. Specify how the results should be sorted. If not specified, the results will be sorted in the default order. For more information, see [Sorting and filtering list results](https://cloud.google.com/kms/docs/sorting-and-filtering). |

### Request body

The request body must be empty.

### Response body

Response message for `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#google.cloud.kms.v1.KeyManagementService.ListKeyRings`.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "keyRings": [ { object (`https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings#KeyRing`) } ], "nextPageToken": string, "totalSize": integer } ``` |

| Fields ||
|---|---|
| `keyRings[]` | ``object (`https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings#KeyRing`)`` The list of `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings#KeyRing`. |
| `nextPageToken` | `string` A token to retrieve next page of results. Pass this value in `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.QUERY_PARAMETERS.page_token` to retrieve the next page of results. |
| `totalSize` | `integer` The total number of `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings#KeyRing` that matched the query. This field is not populated if `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings/list#body.QUERY_PARAMETERS.filter` is applied. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloudkms`
- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).